﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Site-wide global variables hotspot
/// </summary>
public static class Globals
{
	public static readonly int EpisodePerPage = 20;
	public static readonly int ItemsPerFeed = 10;

	// cant be used directly in RSS (needs to be absolute)
	// cant be absolute due to it being used internally during url-rewriting
	private const string LINK_FORMAT_NEWS = "/news/{0}/{1}.aspx";
	private const string LINK_FORMAT_RADIOSHOW = "/radioshow/{0}.aspx";
	private const string LINK_FORMAT_EPISODE = "/episode/{0}/{1}.aspx";

	public static string GetUrl(Episode e)
	{
		return string.Format(LINK_FORMAT_EPISODE, e.RadioShow.Folder, e.Date.ToString("yyyy-MM-dd"));
	}

	public static string GetUrl(RadioShow rs)
	{
		return string.Format(LINK_FORMAT_RADIOSHOW, rs.Folder);
	}

	public static string GetUrl(News n)
	{
		string titleComponent = WebToolkit.UrlTools.FilterAndClean(n.Header).ToLower();
		string dateComponent = n.Date.ToString("yyyy-MM-dd");

		return string.Format(LINK_FORMAT_NEWS, dateComponent, titleComponent);
	}

    public static bool IsIPv6()
    {
        return HttpContext.Current.Request.UserHostAddress.Contains(":");
    }
}
