﻿using System;

public enum QueueStatus
{
    /// <summary>
    /// Queued but not ready to be searched for
    /// </summary>
    Waiting = 0,
    /// <summary>
    /// Queued and ready for scanning
    /// </summary>
    Active = 1,
    /// <summary>
    /// Queued and currently being processed
    /// </summary>
    Processing = 2,
    /// <summary>
    /// Source located and item is ready for download or in the process of downloading
    /// </summary>
    QueuedForDownload = 3,
    /// <summary>
    /// Item is currently downloading.
    /// </summary>
    Downloading = 4,
    /// <summary>
    /// Item is completed and downloaded
    /// </summary>
    Completed = 5,
    /// <summary>
    /// Reserved for future use
    /// </summary>
    Error = 6,
    /// <summary>
    /// Used for queued items which for some reason are to be deactivated
    /// </summary>
    InActive = 7,
    /// <summary>
    /// Reserved for future use
    /// </summary>
    Unkown = 8
}
