﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Xml.Linq;

/// <summary>
/// Quick access functions for DB-data
/// </summary>
public partial class SayuminDataContext
{
    public IQueryable<Episode> GetLatestEpisodes()
    {
        var episodes = from e in this.Episodes
                       orderby e.Date descending
                       select e;
        return episodes;
        return episodes.Take<Episode>(Globals.EpisodePerPage);
    }

    public IQueryable<Episode> GetLatestEpisodes(RadioShow RadioShow)
    {
        var episodes = from e in this.Episodes
                       where e.RadioShow == RadioShow
                       orderby e.Date descending
                       select e;
        return episodes;
        return episodes.Take<Episode>(Globals.EpisodePerPage);
    }

    public Episode GetLatestEpisode(RadioShow RadioShow)
    {
        var episodes = from e in this.Episodes
                       where e.RadioShow == RadioShow
                       orderby e.Date descending
                       select e;
        var episode = episodes.Take<Episode>(1).Single<Episode>();

        return episode;
    }
}

public partial class Episode
{
	public Episode Self
	{
		get { return this; }
	}

    public int NumComments
    {
        get { return this.getNumComments(); }
    }

    public string NumCommentsString
    {
        get { return this.getNumCommentsString(); }
    }

    private int getNumComments()
    {
        var numComments = this.Comments.Count;
        return numComments;
    }

    private string getNumCommentsString()
    {
        int numComments = this.getNumComments();
        string numCommentsString = (numComments == 0) ? "None" : numComments.ToString();

        return numCommentsString;
    }
}

public partial class RadioShow
{
	public RadioShow Self
	{
		get { return this; }
	}

	public string NumCommentsString
	{
		get { return this.getNumCommentsString(); }
	}

	public int NumEpisodes
	{
		get { return this.getNumEpisodes(); }
	}

	private int getNumComments()
	{
		var numComments = this.Comments.Count;
		return numComments;
	}

	private string getNumCommentsString()
	{
		int numComments = this.getNumComments();
		string numCommentsString = (numComments == 0) ? "None" : numComments.ToString();

		return numCommentsString;
	}

	private int getNumEpisodes()
	{
		var numEpisodes = this.Episodes.Count;
		return numEpisodes;
	}

}

public partial class Comment
{
	public string RelatedTitle
	{
		get
		{
			return this.getRelatedTitle();
		}
	}

	private string getRelatedTitle()
	{
		if (this.RadioShow != null)
		{
			return this.RadioShow.DisplayName;
		}

		if (this.News != null)
		{
			return this.News.Header;
		}

		if (this.Episode != null)
		{
			return string.Format("{0} ({1})", this.Episode.RadioShow.DisplayName, this.Episode.Date.ToString("yyyy-MM-dd"));
		}

		return null;
	}
}

public partial class News
{
	public News Self
	{
		get { return this; }
	}

	public string NumCommentsString
	{
		get
		{
			return this.getNumCommentsString();
		}
	}

	private string getNumCommentsString()
	{
		var numComments = this.Comments.Count;

		return (numComments == 0) ? "None" : numComments.ToString();
	}
}