﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public class Smiley
{
	private static List<Smiley> smileys;

	private string match;
	private string url;
	private string alt;

	public string Match { get { return this.match; } }
	public string Url { get { return this.url; } }
	public string Alt { get { return this.alt; } }

	private Smiley(string Match, string Url, string Alt)
	{
		this.match = Match;
		this.url = Url;
		this.alt = Alt;
	}

	static Smiley()
	{
		loadSmileys();
	}

	private static void loadSmileys()
	{
		smileys = new List<Smiley>();

		var fileName = HttpContext.Current.Server.MapPath("~/App_Data/smileys.txt");
		var lines = System.IO.File.ReadAllLines(fileName);

		for (int i=0; i < lines.Length; i += 3)
		{
			try
			{
				var smiley = new Smiley(lines[i], lines[i+1], lines[i+2]);
				smileys.Add(smiley);
			}
			catch (ArgumentOutOfRangeException ex)
			{}
		}
	}

	public override string ToString()
	{
		const string FORMAT = "<img src=\"http://media.sayumin.org/.images/smileys/{0}\" alt=\"{1}\" width=\"20\" height=\"20\" />";
		return string.Format(FORMAT, this.url, this.alt);
	}

	public static string Apply(string text)
	{
		foreach (var smiley in smileys)
		{
			text = text.Replace(smiley.Match, smiley.ToString());
		}
		return text;
	}
}
