﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using WebToolkit;

public partial class CommentForm : System.Web.UI.UserControl
{
    public Comment Comment { get; set; }
    public CommandEventHandler QuoteHandler { get; set; }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.QuoteHandler != null)
        {
            this.bQuote.Command += this.QuoteHandler;
        }

        if (this.Comment == null)
        {
            return;
        }

        this.bQuote.CommandArgument = this.Comment.ID.ToString();
        this.litDate.Text = this.Comment.PostDate.ToString("yyyy-MM-dd");
        this.litNick.Text = this.formatNickName(this.Comment.Nick, this.Comment.Website);
        this.litText.Text = this.applyBBcode(this.Comment.Text);
    }

    private string applyBBcode(string text)
    {
        return "<p>" + BBcode.BBdecode(text) + "</p>";
    }

    private string formatNickName(string nick, string website)
    {
        if (website == "")
        {
            return string.Format("<b>{0}</b>", nick);
        }
        return string.Format("<a href=\"{0}\">{1}</a>", website, nick);
    }
}
