USE [Sayumin]
GO
/****** Object:  Table [dbo].[RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[RadioShow](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[DisplayName] [nvarchar](100) NOT NULL,
	[FileNameBase] [varchar](100) NOT NULL,
	[Folder] [varchar](100) NOT NULL,
	[Text] [nvarchar](max) NOT NULL,
	[RetainEpisodes] [int] NOT NULL,
 CONSTRAINT [PK_RadioShow] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[ErrorLog]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[ErrorLog](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[Module] [nvarchar](200) NOT NULL,
	[ErrorText] [nvarchar](max) NOT NULL,
	[Time] [datetime] NOT NULL,
 CONSTRAINT [PK_ErrorLog] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Scanner]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[Scanner](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[DisplayName] [nvarchar](200) NOT NULL,
	[AssemblyName] [varchar](300) NOT NULL,
	[TypeName] [varchar](300) NOT NULL,
 CONSTRAINT [PK_Scanner] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[Source]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[Source](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[DisplayName] [nvarchar](200) NOT NULL,
	[ServerID] [varchar](200) NOT NULL,
	[AssemblyName] [varchar](300) NOT NULL,
	[Configuration] [nvarchar](max) NULL,
	[TypeName] [varchar](300) NOT NULL,
 CONSTRAINT [PK_Source] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[Schedule]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Schedule](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[RadioShowID] [int] NOT NULL,
	[DayOfWeek] [int] NOT NULL,
	[StartDay] [int] NOT NULL,
	[StartTime] [datetime] NOT NULL,
	[IsActive] [bit] NOT NULL,
 CONSTRAINT [PK_Schedule] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[RadioshowSource]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[RadioshowSource](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[RadioShowID] [int] NOT NULL,
	[SourceID] [int] NOT NULL,
	[ScannerID] [int] NOT NULL,
	[Priority] [int] NOT NULL,
	[Configuration] [nvarchar](max) NOT NULL,
 CONSTRAINT [PK_RadioshowSource] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[News]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[News](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[RelatedRadioShowID] [int] NULL,
	[IsActive] [bit] NOT NULL,
	[Date] [datetime] NOT NULL,
	[Header] [nvarchar](200) NOT NULL,
	[Text] [nvarchar](max) NOT NULL,
 CONSTRAINT [PK_News] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[FileQueue]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[FileQueue](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[RadioShowID] [int] NOT NULL,
	[ScheduleID] [int] NOT NULL,
	[Status] [int] NOT NULL,
	[EpisodeDate] [datetime] NOT NULL,
	[URL] [nvarchar](500) NULL,
	[ServerID] [varchar](200) NULL,
	[StartTime] [datetime] NOT NULL,
	[Attempts] [int] NOT NULL,
	[UploadDate] [datetime] NULL,
 CONSTRAINT [PK_Queue] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [IX_Queue_RadioShow_EpisodeDate] UNIQUE NONCLUSTERED 
(
	[RadioShowID] ASC,
	[EpisodeDate] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[Episode]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[Episode](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[RadioShowID] [int] NOT NULL,
	[ScheduleID] [int] NOT NULL,
	[Date] [datetime] NOT NULL,
	[FetchDate] [datetime] NOT NULL,
	[Size] [bigint] NOT NULL,
	[IsAvailable] [bit] NOT NULL,
	[PublicURL] [varchar](200) NOT NULL,
 CONSTRAINT [PK_Episode] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [IX_Episode] UNIQUE NONCLUSTERED 
(
	[RadioShowID] ASC,
	[Date] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  View [dbo].[vActiveFileQueue]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[vActiveFileQueue]
AS
SELECT fq.ID, fq.RadioShowID, fq.ScheduleID, fq.ServerID, fq.StartTime, fq.EpisodeDate, fq.Status, fq.UploadDate, fq.URL
FROM FileQueue fq
WHERE Status <= 2
GO
/****** Object:  Table [dbo].[Comment]    Script Date: 09/15/2010 21:04:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Comment](
	[ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[EpisodeID] [int] NULL,
	[RadioshowID] [int] NULL,
	[NewID] [int] NULL,
	[PostDate] [datetime] NOT NULL,
	[Nick] [nvarchar](100) NOT NULL,
	[Text] [nvarchar](max) NOT NULL,
	[Website] [nvarchar](300) NOT NULL,
 CONSTRAINT [PK_Comment] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Default [DF_Comment_PostDate]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Comment] ADD  CONSTRAINT [DF_Comment_PostDate]  DEFAULT (getdate()) FOR [PostDate]
GO
/****** Object:  Default [DF_Comment_Website]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Comment] ADD  CONSTRAINT [DF_Comment_Website]  DEFAULT ('') FOR [Website]
GO
/****** Object:  Default [DF_Episode_Size]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Episode] ADD  CONSTRAINT [DF_Episode_Size]  DEFAULT ((0)) FOR [Size]
GO
/****** Object:  Default [DF_ErrorLog_Time]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[ErrorLog] ADD  CONSTRAINT [DF_ErrorLog_Time]  DEFAULT (getdate()) FOR [Time]
GO
/****** Object:  Default [DF_Queue_Status]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[FileQueue] ADD  CONSTRAINT [DF_Queue_Status]  DEFAULT ((0)) FOR [Status]
GO
/****** Object:  Default [DF_RadioshowSource_Priority]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[RadioshowSource] ADD  CONSTRAINT [DF_RadioshowSource_Priority]  DEFAULT ((10)) FOR [Priority]
GO
/****** Object:  Default [DF_Schedule_IsActive]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Schedule] ADD  CONSTRAINT [DF_Schedule_IsActive]  DEFAULT ((1)) FOR [IsActive]
GO
/****** Object:  Check [CK_Comment_Ref]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Comment]  WITH CHECK ADD  CONSTRAINT [CK_Comment_Ref] CHECK  (([EpisodeID] IS NOT NULL OR [NewID] IS NOT NULL OR [RadioshowID] IS NOT NULL))
GO
ALTER TABLE [dbo].[Comment] CHECK CONSTRAINT [CK_Comment_Ref]
GO
/****** Object:  Check [CK_Episode_Size]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Episode]  WITH CHECK ADD  CONSTRAINT [CK_Episode_Size] CHECK  (([Size]<>(0)))
GO
ALTER TABLE [dbo].[Episode] CHECK CONSTRAINT [CK_Episode_Size]
GO
/****** Object:  ForeignKey [FK_Comment_Episode]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Comment]  WITH CHECK ADD  CONSTRAINT [FK_Comment_Episode] FOREIGN KEY([EpisodeID])
REFERENCES [dbo].[Episode] ([ID])
GO
ALTER TABLE [dbo].[Comment] CHECK CONSTRAINT [FK_Comment_Episode]
GO
/****** Object:  ForeignKey [FK_Comment_News]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Comment]  WITH CHECK ADD  CONSTRAINT [FK_Comment_News] FOREIGN KEY([NewID])
REFERENCES [dbo].[News] ([ID])
GO
ALTER TABLE [dbo].[Comment] CHECK CONSTRAINT [FK_Comment_News]
GO
/****** Object:  ForeignKey [FK_Comment_RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Comment]  WITH CHECK ADD  CONSTRAINT [FK_Comment_RadioShow] FOREIGN KEY([RadioshowID])
REFERENCES [dbo].[RadioShow] ([ID])
GO
ALTER TABLE [dbo].[Comment] CHECK CONSTRAINT [FK_Comment_RadioShow]
GO
/****** Object:  ForeignKey [FK_Episode_RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Episode]  WITH CHECK ADD  CONSTRAINT [FK_Episode_RadioShow] FOREIGN KEY([RadioShowID])
REFERENCES [dbo].[RadioShow] ([ID])
GO
ALTER TABLE [dbo].[Episode] CHECK CONSTRAINT [FK_Episode_RadioShow]
GO
/****** Object:  ForeignKey [FK_Episode_Schedule]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Episode]  WITH CHECK ADD  CONSTRAINT [FK_Episode_Schedule] FOREIGN KEY([ScheduleID])
REFERENCES [dbo].[Schedule] ([ID])
GO
ALTER TABLE [dbo].[Episode] CHECK CONSTRAINT [FK_Episode_Schedule]
GO
/****** Object:  ForeignKey [FK_Queue_RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[FileQueue]  WITH CHECK ADD  CONSTRAINT [FK_Queue_RadioShow] FOREIGN KEY([RadioShowID])
REFERENCES [dbo].[RadioShow] ([ID])
GO
ALTER TABLE [dbo].[FileQueue] CHECK CONSTRAINT [FK_Queue_RadioShow]
GO
/****** Object:  ForeignKey [FK_Queue_Schedule]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[FileQueue]  WITH CHECK ADD  CONSTRAINT [FK_Queue_Schedule] FOREIGN KEY([ScheduleID])
REFERENCES [dbo].[Schedule] ([ID])
GO
ALTER TABLE [dbo].[FileQueue] CHECK CONSTRAINT [FK_Queue_Schedule]
GO
/****** Object:  ForeignKey [FK_News_RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[News]  WITH CHECK ADD  CONSTRAINT [FK_News_RadioShow] FOREIGN KEY([RelatedRadioShowID])
REFERENCES [dbo].[RadioShow] ([ID])
GO
ALTER TABLE [dbo].[News] CHECK CONSTRAINT [FK_News_RadioShow]
GO
/****** Object:  ForeignKey [FK_RadioshowSource_RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[RadioshowSource]  WITH CHECK ADD  CONSTRAINT [FK_RadioshowSource_RadioShow] FOREIGN KEY([RadioShowID])
REFERENCES [dbo].[RadioShow] ([ID])
GO
ALTER TABLE [dbo].[RadioshowSource] CHECK CONSTRAINT [FK_RadioshowSource_RadioShow]
GO
/****** Object:  ForeignKey [FK_RadioshowSource_Scanner]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[RadioshowSource]  WITH CHECK ADD  CONSTRAINT [FK_RadioshowSource_Scanner] FOREIGN KEY([ScannerID])
REFERENCES [dbo].[Scanner] ([ID])
GO
ALTER TABLE [dbo].[RadioshowSource] CHECK CONSTRAINT [FK_RadioshowSource_Scanner]
GO
/****** Object:  ForeignKey [FK_RadioshowSource_Source]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[RadioshowSource]  WITH CHECK ADD  CONSTRAINT [FK_RadioshowSource_Source] FOREIGN KEY([SourceID])
REFERENCES [dbo].[Source] ([ID])
GO
ALTER TABLE [dbo].[RadioshowSource] CHECK CONSTRAINT [FK_RadioshowSource_Source]
GO
/****** Object:  ForeignKey [FK_Schedule_RadioShow]    Script Date: 09/15/2010 21:04:55 ******/
ALTER TABLE [dbo].[Schedule]  WITH CHECK ADD  CONSTRAINT [FK_Schedule_RadioShow] FOREIGN KEY([RadioShowID])
REFERENCES [dbo].[RadioShow] ([ID])
GO
ALTER TABLE [dbo].[Schedule] CHECK CONSTRAINT [FK_Schedule_RadioShow]
GO
