﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sayumin.Common
{
    /// <summary>
    /// Abstract base-class for configurable classes.
    /// </summary>
    public abstract class ConfigReader : IConfigurable
    {
        public ConfigReader()
        {
            _settings = new Dictionary<string, string>();
        }

        protected Dictionary<string, string> _settings;

        /// <summary>
        /// Initialises the settings based on DB-configuration
        /// </summary>
        /// <param name="Settings">Settings should be a key/pair-values seperated by semicolons with equality for assignemnt.</param>
        public virtual void InitSettings(string Settings)
        {
            if (false == string.IsNullOrEmpty(Settings))
            {
                string[] pairs = Settings.Split(';');

                foreach (string pair in pairs)
                {
                    string[] keyValue = pair.Split(new char[] { '=' }, 2);
                    string key = keyValue[0].ToLower();
                    string value = keyValue[1];

                    _settings[key] = value;
                }
            }
        }
    }
}
