﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace Sayumin.Common
{
    /// <summary>
    /// Class which provides regex matching for description field,
    /// and an optional regex match on data from the Columns-collection
    /// of the FileEntry object.
    /// </summary>
    public class ExtendedScanner : RegexScanner
    {
        protected override bool MatchAdditional(FileEntry Entry)
        {
            if (false == _settings.Keys.Contains("matchkey")
                || false == _settings.Keys.Contains("matchvalue"))
            {
                return true;
            }

            string matchKey = _settings["matchkey"];
            string matchValue = _settings["matchvalue"];

            bool isMatch = false;

            string matchData = Entry.Columns[matchKey.ToLower()];
            if (matchKey != null)
            {
                isMatch = Regex.IsMatch(matchData, matchValue);
            }

            return isMatch;
        }
    }
}
