﻿using System;
using System.Reflection;

namespace Sayumin.Common
{
    public abstract class ModuleLoader<T>
    {
        protected Assembly _assembly;
        protected Type _type;

        public void LoadAssembly()
        {
            string interfaceName = typeof(T).Name;

            try
            {
                // load assembly from disk
                _assembly = Assembly.Load(GetAssemblyName());

            }
            catch (Exception)
            {
                // dont break entire application due to errorenous DLLs
            }
        }

        public T GetInstance()
        {
            if (_assembly == null)
            {
                LoadAssembly();
            }

            T module = default(T);
            try
            {
                module = (T)_assembly.CreateInstance(GetTypeName());
            }
            catch (Exception) { }
            return module;
        }

        //public string GetModuleName()
        //{
        //    return _type.FullName;
        //}

        protected abstract string GetAssemblyName();

        protected abstract string GetTypeName();
    }
}
