namespace Sayumin.Common.DAC
{
    using System;
    using System.Data.SqlClient;

    public partial class SayuminDataContext
    {
        public bool SubmitChangesAndIgnoreDuplicates()
        {
            bool hasDuplicates = false;
            try
            {
                this.SubmitChanges();
            }
            catch (SqlException ex)
            {
                foreach (SqlError error in ex.Errors)
                {
                    if (error.Number == 2627)
                    {
                        hasDuplicates = true;
                        break;
                    }
                }

                if (false == hasDuplicates)
                {
                    // all other exceptions should be logged
                    throw ex;
                }
            }
            return hasDuplicates;
        }
    }

    partial class Scanner : ModuleLoader<IRadioScanner>
    {
        protected override string GetAssemblyName()
        {
            return this.AssemblyName;
        }

        protected override string GetTypeName()
        {
            return this.TypeName;
        }
    }

    public partial class Source : ModuleLoader<IFileSource>
    {
        protected override string GetAssemblyName()
        {
            return this.AssemblyName;
        }

        protected override string GetTypeName()
        {
            return this.TypeName;
        }
    }

    public partial class Schedule
    {
        public DayOfWeek DayOfWeekAired
        {
            get
            {
                return (DayOfWeek)DayOfWeek;
            }
        }
    }

    public partial class FileQueue
    {
        public QueueStatus Status
        {
            get
            {
                return (QueueStatus)StatusNumber;
            }
            set
            {
                StatusNumber = (int)value;
            }
        }
    }
}
