﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sayumin.Common
{
    public interface IFileSource
    {
        /// <summary>
        /// Used for caching and to avoid needless server-hammering.
        /// </summary>
        DateTime LastUpdated { get; set; }

        /// <summary>
        /// Should scan source and return complete list of files with known meta-data.
        /// </summary>
        /// <returns>List of all files present on page 1 of the source.</returns>
        FileEntry[] GetEntries();
    }
}
