﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sayumin.Common
{
    public interface IRadioScanner
    {
        /// <summary>
        /// Determines if there is a match based on input. Returns null if not.
        /// </summary>
        /// <param name="Entries">A list of plausable FileEntries</param>
        /// <param name="EpisodeDate">The airdate of the specific episode.</param>
        /// <param name="ConfigData">Settings should be a key/pair-values seperated by semicolons with equality for assignemnt.</param>
        /// <returns>A matching FileEntry object or null if none found.</returns>
        FileEntry FindMatch(FileEntry[] Entries, DateTime EpisodeDate);
    }
}
