﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sayumin.Common.DAC;

namespace Sayumin.Common
{
    public class DbLogger : ILogModule
    {
        protected string _module;

        protected SayuminDataContext db;

        public DbLogger(string Module)
        {
            _module = Module;
            db = new SayuminDataContext();
        }

        #region ILogModule Members

        public void Write(string Message)
        {
            // ignore. ErrorLog is for errors only.
        }

        public void WriteError(string Message)
        {
            WriteToDb(_module, Message);
        }

        public void WriteError(string Message, Exception Exception)
        {
            string message = string.Format("{0} - Error details - {1} - Stack trace", Message, Exception.Message, Exception.StackTrace);
            WriteToDb(_module, message);
        }

        protected void WriteToDb(string Module, string Text)
        {
            ErrorLog entry = new ErrorLog();

            entry.Module = Module;
            entry.ErrorText = Text;
            entry.Time = DateTime.Now;

            lock (db)
            {
                db.ErrorLogs.InsertOnSubmit(entry);
                db.SubmitChanges();
            }
        }

        #endregion
    }
}
