﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace Sayumin.Common
{
    public class EventLogLogger : ILogModule
    {
        protected EventLog _eventLog;

        public EventLogLogger(string ModuleName)
        {
            _eventLog = new EventLog("Application");
            _eventLog.Source = ModuleName;
        }

        #region ILogModule Members

        public void Write(string Message)
        {
            _eventLog.WriteEntry(Message, EventLogEntryType.Information);
        }

        public void WriteError(string Message)
        {
            _eventLog.WriteEntry(Message, EventLogEntryType.Error);
        }

        public void WriteError(string Message, Exception Exception)
        {
            string logMessage = string.Empty;
            logMessage += string.Format("{0}", Message);
            logMessage += string.Format(" - Details: {0}", Exception);
            logMessage += string.Format(" - Stacktrace: {0}", Exception.StackTrace);

            _eventLog.WriteEntry(logMessage, EventLogEntryType.Error);

        }

        #endregion
    }
}
