﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sayumin.Common
{
    public class MultiLogger : ILogModule
    {
        protected List<ILogModule> _modules;

        public List<ILogModule> Modules
        {
            get
            {
                return _modules;
            }
        }

        public MultiLogger()
        {
            _modules = new List<ILogModule>();
        }

        #region ILogModule Members

        public void Write(string Message)
        {
            foreach (ILogModule module in _modules)
            {
                module.Write(Message);
            }
        }

        public void WriteError(string Message)
        {
            foreach (ILogModule module in _modules)
            {
                module.WriteError(Message);
            }
        }

        public void WriteError(string Message, Exception Exception)
        {
            foreach (ILogModule module in _modules)
            {
                module.WriteError(Message, Exception);
            }
        }

        #endregion
    }
}
