﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sayumin.Common;

namespace Sayumin.Modules.Usachan
{
    public class UsachanSource : BaseSource
    {
        public UsachanSource()
            : base()
        {
        }

        public override void InitSettings(string Settings)
        {
            base.InitSettings(Settings);

            if (_settings["url"] == null)
            {
                // unconfigured. override at will.
                _settings["url"] = "http://sayu.no-ip.com/usachan/peace.php";
                _settings["tagdelimiter"] = "'";
            }
        }

        protected override void ReformatData()
        {
            // create columns which aren't there to assist processing

            string data = _scraper.Data;
            
            data = data.Replace("説明</th>", "説明</th><th>Date</th><th>Del</th><th>Orig</th>");
            data = data.Replace("<br>", "</td><td>");
            data = data.Replace("[<a href='/usachan/peace.php?del=", "</td><td>[<a href='/usachan/peace.php?del=");

            _scraper.Data = data;
        }
    }
}
