﻿using System;
using System.Configuration;
using Tamir.SharpSsh;

namespace Sayumin.QueueDownloader
{
    public class MediaServerHandler : IDisposable
    {
        private string cleanupCommand;

        private SshExec shell;
        private string rootDir;

        public string Messages { get; set; }

        public MediaServerHandler()
        {
            string host = ConfigurationSettings.AppSettings["host"];
            string username = ConfigurationSettings.AppSettings["username"];
            string password = ConfigurationSettings.AppSettings["password"];
            rootDir = ConfigurationSettings.AppSettings["rootdir"];
            cleanupCommand = ConfigurationSettings.AppSettings["cleanupCommand"];

            shell = new SshExec(host, username, password);
            shell.Connect();
            Messages = "";
        }

        public void DownloadData(string url, string folder, string localName, int retainEpisodes)
        {
            string userAgent = "wget (http://www.sayumin.org)";
            //if (url.StartsWith("http://hm723.sakura.ne.jp"))
            //{
            //    userAgent = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0)";
            //}

            Messages += shell.RunCommand(string.Format("mkdir -p '{0}' ; cd '{0}'", this.rootDir + folder));
            Messages += shell.RunCommand(string.Format("wget --user-agent=\"{2}\" -O '{0}' '{1}'", this.rootDir + folder + "/" + localName, url, userAgent));
            //Messages += shell.RunCommand(string.Format("/usr/bin/wget -O '{0}' '{1}'", this.rootDir + folder + "/" + localName, url));
            Messages += shell.RunCommand(string.Format(cleanupCommand, retainEpisodes, this.rootDir + folder));
        }

        #region IDisposable Members

        public void Dispose()
        {
            if (shell != null && shell.Connected)
            {
                shell.Close();
            }
        }

        #endregion
    }
}
