﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Sayumin.Common;

namespace Sayumin.Tests.Common
{
    /// <summary>
    /// Summary description for InferringScannerTest
    /// </summary>
    [TestClass]
    public class InferringScannerTest
    {
        public InferringScannerTest()
        {
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestInferringScanner()
        {
            BaseSource bs = new BaseSource();
            bs.InitSettings("url=http://konchan.fam.cx/0412/hello/upload.php");

            InferringScanner scanner = new InferringScanner();
            //scanner.InitSettings(@"desc=JAM PUNCH!;infer=year;dateformat=((?<Y>(\d{2}|\d{4}))/)?(?<M>\d{1,2})/(?<D>\d{1,2})");
            scanner.InitSettings(@"desc=JAM PUNCH!;infer=year;dateformat=(?<M>\d{1,2})/(?<D>\d{1,2})");

            FileEntry[] entries = bs.GetEntries();
            Assert.AreNotEqual<int>(0, entries.Length, "There should be source data.");

            DateTime episodeDate = new DateTime(2009, 3, 6);
            FileEntry match = scanner.FindMatch(entries, episodeDate);

            Assert.IsNotNull(match, "Inferring should give a match.");
        }
    }
}
