﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Sayumin.Common.DAC;

namespace Sayumin.Tests.SourceConfig
{
    public partial class OpenRadioshowForm : Form
    {
        protected RadioShow[] _shows;
        protected RadioShow _selectedShow;

        public RadioShow SelectedShow
        {
            get { return _selectedShow; }
        }

        public OpenRadioshowForm()
        {
            InitializeComponent();
        }

        public void PopulateRadioShows(RadioShow[] RadioShows)
        {
            _shows = RadioShows;
            lbRadioshows.DisplayMember = "DisplayName";
            lbRadioshows.ValueMember = "ID";
            lbRadioshows.DataSource = _shows;
        }

        private void bOpen_Click(object sender, EventArgs e)
        {
            if (lbRadioshows.SelectedItem == null)
            {
                return;
            }

            _selectedShow = (RadioShow)lbRadioshows.SelectedItem;
            this.Close();
        }

        private void bCancel_Click(object sender, EventArgs e)
        {
            _selectedShow = null;
            this.Close();
        }
    }
}
