﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Sayumin.Tests.SourceConfig
{
    public partial class SaveRadioshowForm : Form
    {
        public string DisplayName
        {
            get
            {
                return txtDisplayName.Text;
            }
        }

        public string FolderName
        {
            get
            {
                return txtFolderName.Text;
            }
        }

        public string FilenameBase
        {
            get
            {
                return txtFileNameBase.Text;
            }
        }

        public int RetainEpisodes
        {
            get
            {
                return int.Parse(txtRetainEpisodes.Text);
            }
        }

        public bool SaveConfirmed { get; set; }

        public SaveRadioshowForm()
        {
            InitializeComponent();
        }

        private void bSave_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(DisplayName))
                return;

            if (string.IsNullOrEmpty(FolderName))
                return;

            if (string.IsNullOrEmpty(FilenameBase))
                return;

            int retainEpisodes;
            if (false == int.TryParse(txtRetainEpisodes.Text, out retainEpisodes))
                return;

            SaveConfirmed = true;
            this.Close();
        }

        private void bCancel_Click(object sender, EventArgs e)
        {
            SaveConfirmed = false;
            this.Close();
        }
    }
}
