﻿<%@ WebHandler Language="C#" Class="EpisodeLength" %>

using System;
using System.Web;
using System.Linq;

public class EpisodeLength : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        context.Response.ContentType = "text/plain";
        //context.Response.Write("Hello World");

        w("Getting length for episodes.");

        var db = new SayuminDataContext();
        var query = from e in db.Episodes
                    where e.Size == 0
                    select e;

        foreach (var episode in query)
        {
            w("Processing {0} - {1}", episode.RadioShow.DisplayName, episode.Date.ToString("yyyy-MM-dd"));
            var url = episode.PublicURL;
            var size = getSize(url);
            w("Size found: {0}. Updating.", size);

            episode.Size = size;
            db.SubmitChanges();

            w("Saved");
        }
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

    private void w(string text)
    {
        HttpContext.Current.Response.Write(text + "\n");
        HttpContext.Current.Response.Flush();
    }

    private void w(string format, params object[] parameters)
    {
        this.w(string.Format(format, parameters));
    }

    public long getSize(string url)
    {
        var wc = new System.Net.WebClient();

        var stream = wc.OpenRead(url);
        var headers = wc.ResponseHeaders;

        long size = 0;
        for (int i = 0; i < headers.Count; i++)
        {
            if (headers.GetKey(i).ToLower() == "content-length")
            {
                size = Convert.ToInt64(headers.Get(i));
                break;
            }
            //context.Response.Write(headers.GetKey(i) + " = " + headers.Get(i) + "\n");
        }

        stream.Close();

        return size;
    }

}