﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_NewsEdit : System.Web.UI.Page
{
	private int newsID;
	private SayuminDataContext db;

	protected void Page_Load(object sender, EventArgs e)
	{
		this.newsID = int.Parse(Request.QueryString["ID"]);
		this.db = new SayuminDataContext();

		if ((!Page.IsPostBack) && (this.newsID != 0))
		{
			this.renderNews();
		}
	}

	protected void lnkConfirm_Click(object sender, EventArgs e)
	{
		var news = this.getNews();

		if (this.newsID == 0)
		{
			db.News.InsertOnSubmit(news);
		}

		db.SubmitChanges();

		Response.Redirect("/admin/News.aspx");
	}

	protected void lnkPreview_Click(object sender, EventArgs e)
	{
		NewsViewer nv = (NewsViewer)Page.LoadControl("~/usercontrols/NewsViewer.ascx");
		nv.News = this.getNews();
		nv.FillInData();

		this.pPreview.Controls.Add(nv);
	}

	private News getNews()
	{
		News news;

		if (this.newsID != 0)
		{
			news = (from n in this.db.News
					where n.ID == this.newsID
					select n).Single();
		}
		else
		{
			news = new News();
			news.Date = DateTime.Now;
		}

		news.Header = this.txtHeader.Text;
		news.Text = this.txtContent.Text;
		news.IsActive = this.cbIsActive.Checked;

		if (this.cbRadioShows.Checked)
		{
			news.RelatedRadioShowID = int.Parse(this.ddlRadioShows.SelectedValue);
		}

		return news;
	}

	private void renderNews()
	{
		var news = (from n in this.db.News
					where n.ID == this.newsID
					select n).Single();

		this.txtHeader.Text = news.Header;
		this.txtContent.Text = news.Text;
		this.cbIsActive.Checked = news.IsActive;

		if (news.RadioShow != null)
		{
			this.cbRadioShows.Checked = true;
			this.ddlRadioShows.SelectedValue = news.RelatedRadioShowID.ToString();
		}
		else
		{
			this.cbRadioShows.Checked = false;
		}
	}

	protected void cbRadioShows_CheckedChanged(object sender, EventArgs e)
	{
		this.ddlRadioShows.Enabled = this.cbRadioShows.Checked;
	}
}
