﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class EpisodePage : System.Web.UI.Page
{
	protected void Page_PreInit(object sender, EventArgs e)
	{
		if (!Request.RawUrl.StartsWith("/episode.aspx"))
		{
			Context.RewritePath(VirtualPathUtility.GetDirectory(Request.RawUrl) + VirtualPathUtility.GetFileName(Request.RawUrl));
		}
	}

	protected void Page_Load(object sender, EventArgs e)
    {
        int episodeID = 0;
        int.TryParse(Request.QueryString["ID"], out episodeID);

        var db = new SayuminDataContext();

        if (episodeID != 0)
        {
            var episodes = from ep in db.Episodes
                          where ep.ID == episodeID
                          select ep;
            var episode = episodes.Single();

            var title = string.Format("{0} - {1:yyyy-MM-dd}", episode.RadioShow.DisplayName, episode.Date);
            this.Header.Title = "sayumin.org: " + title;
            this.litTitle.Text = title;

            this.EpisodeLister1.Episodes = episodes;
            this.EpisodeLister1.Header = "Episode";
            this.EpisodeLister1.ShowPreface = false;
            this.RadioShowViewer1.RadioShow = episode.RadioShow;

			this.lnkEpisodes.HRef = Globals.GetUrl(episode.RadioShow);

            this.CommentViewer1.CommentObject = episode;
        }
        else
        {
            this.EpisodeLister1.Episodes = db.GetLatestEpisodes();
        }
    }
}
