﻿<%@ WebHandler Language="C#" Class="Episodes_iTunes" %>

using System;
using System.Web;
using System.Linq;

public class Episodes_iTunes : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        var db = new SayuminDataContext();

        int radioShowID = 0;
        int.TryParse(context.Request.QueryString["ID"], out radioShowID);

        context.Response.ContentType = "application/pcast+xml";

        try
        {

            RadioShow radioShow;
            string description = "sayumin.org: ";
            string filename = string.Format("sayumin.org-{0}.pcast", radioShowID);
            context.Response.AddHeader("Content-Disposition", "inline;filename=" + filename);

            if (radioShowID != 0)
            {
                radioShow = (from rs in db.RadioShows
                             where rs.ID == radioShowID
                             select rs).Single();

                description += radioShow.DisplayName;
                
            }
            else
            {
                description += "All shows";
            }

            var pcastTemplate = System.IO.File.ReadAllText(@"C:\inetpub\sites\org.sayumin.www\rss\podcast.xml");

            var pcastContent = string.Format(pcastTemplate, radioShowID, description);

            context.Response.Write(pcastContent);
        }
        catch (Exception) { }
    }
 
    public bool IsReusable {
        get {
            return true;
        }
    }

}