﻿<%@ WebHandler Language="C#" Class="Errors" %>

using System;
using System.Web;
using System.Linq;
using System.Xml.Linq;
using System.Collections.Generic;
using System.Data;
using RssComponents;

public class Errors : IHttpHandler {
    private const string CONTENT_FORMAT = @"<h2>Error in module {0}</h2>
<p><b>Time of error:</b> {1:yyyy-MM-dd hh:mm}<br/>
<b>Errortext:</b><br />{2}";
        
    public void ProcessRequest (HttpContext context)
    {
        var db = new SayuminDataContext();

        context.Response.ContentType = "application/rss+xml";

        string feedtext = "";
        try
        {
            string description = "sayumin.org: Errors";

            RssFeed feed = new RssFeed(
                description,
                "http://www.sayumin.org/",
                description,
                "EN-US", context.Request.Url.AbsoluteUri);

            var query = (from e in db.ErrorLogs
                         orderby e.ID descending
                         select e).Take(20);
            
            foreach (var error in query)
            {
                var title = error.Module;
                var comment = string.Format(CONTENT_FORMAT, error.Module, error.Time, error.ErrorText);
                
                var item = new RssItem(title, "http://www.sayumin.org", comment, error.Time);
                feed.Items.Add(item);
            }

            feedtext = feed.ToString();
        }
        catch (Exception)
        { }

        context.Response.Write(feedtext);
    }
 
    public bool IsReusable {
        get {
            return true;
        }
    }

}