﻿<%@ WebHandler Language="C#" Class="NewsFeed" %>

using System;
using System.Web;
using System.Linq;
using System.Xml.Linq;
using System.Collections.Generic;
using System.Data;
using RssComponents;
using WebToolkit;

public class NewsFeed : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        var db = new SayuminDataContext();

        context.Response.ContentType = "application/rss+xml";

        string feedtext = "";
        try
        {
            RssFeed feed = new RssFeed(
	            "sayumin.org news-feed",
	            "http://www.sayumin.org/",
				"site-news and technical reports in case of difficulties",
				"EN-US", "http://www.sayumin.org/");

            var news = (from n in db.News
                        where n.IsActive == true
                        orderby n.Date descending
                        select n).Take(Globals.ItemsPerFeed);

            foreach (var newsItem in news)
            {
                var description = BBcode.BBdecode(BBcode.Shorten(newsItem.Text, 400));
                var link = "http://www.sayumin.org" + Globals.GetUrl(newsItem);
                var comments = link + "#comments";

                var feedItem = new RssItem(newsItem.Header, link, description, newsItem.Date, link, comments);

                feed.Items.Add(feedItem);
            }

            feedtext = feed.ToString();
        }
        catch (Exception)
        { }

        context.Response.Write(feedtext);            
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}