﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class EpisodeLister : System.Web.UI.UserControl
{
    public string Header
    {
        set { this.lblHeader.Text = value; }
        get { return this.lblHeader.Text; }
    }

    public bool ShowPreface
    {
        set
        {
            this.pEpisodeListPreface.Visible = value;
            this.tableHeaderRow.Visible = value;
        }
    }

    public string PagerLinkPrefix
    {
        get;
        set;
    }

	private int currentPage;

    public IQueryable<Episode> Episodes
    {
        get; set; 
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (false == int.TryParse(Request["page"], out currentPage))
        {
            currentPage = 1;
        }

		if (!Page.IsPostBack)
		{
			prepareUI();
		}
	}

	private void prepareUI()
	{
		// get the facts
		int numEpisodes = 0;
		bool hasEpisodes = (this.Episodes != null);
		if (hasEpisodes)
		{
			numEpisodes = this.Episodes.Count();
			hasEpisodes = numEpisodes != 0;
		}

		// setup links
		bool showPrevious = currentPage != 1;
		bool showNext = (numEpisodes > ((currentPage) * Globals.EpisodePerPage));

        this.lnkPrevious.Visible = false;
        this.lnkNext.Visible = false;
        if (showPrevious)
        {
            this.lnkPrevious.Visible = true;
            this.lnkPrevious.HRef = string.Format("{0}?page={1}", PagerLinkPrefix, (currentPage - 1));
        }
        if (showNext)
        {
            this.lnkNext.Visible = true;
            this.lnkNext.HRef = string.Format("{0}?page={1}", PagerLinkPrefix, (currentPage + 1));
        }

		this.trEpisodes.Visible = (showPrevious || showNext);

		// bind DB-data
		this.pEpisodeList.Visible = hasEpisodes;
		this.pNoEpisodes.Visible = !hasEpisodes;

		if (hasEpisodes)
		{
			if (this.currentPage == 0)
			{
                this.rEpisodes.DataSource = this.Episodes.Take(Globals.EpisodePerPage);
			}
			else
			{
				this.rEpisodes.DataSource = this.Episodes.Skip(Globals.EpisodePerPage * (currentPage -1)).Take(Globals.EpisodePerPage);
			}
			this.rEpisodes.DataBind();
		}
	}
}
