﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class QueueViewer : System.Web.UI.UserControl
{
    public string Header
    {
        set { this.lblHeader.Text = value; }
        get { return this.lblHeader.Text; }
    }

    public bool ShowPreface
    {
        set
        {
            this.pQueuePreface.Visible = value;
        }
    }

    public IQueryable<FileQueue> Queue
    {
        get; set; 
    }

    protected void Page_Load(object sender, EventArgs e)
    {
		if (!Page.IsPostBack)
		{
			prepareUI();
		}
	}

	private void prepareUI()
	{
		// get the facts
		int numQueue = 0;
		bool hasQueue = (this.Queue != null);
		if (hasQueue)
		{
			numQueue = this.Queue.Count();
			hasQueue = hasQueue && (numQueue != 0);
		}

		// setup links

		// bind DB-data
		this.pQueue.Visible = hasQueue;
		this.pNoQueue.Visible = !hasQueue;

		if (hasQueue)
		{
			this.rQueue.DataSource = this.Queue;
			this.rQueue.DataBind();
		}
	}
}
