﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Text;

public partial class TwoColukmnView : System.Web.UI.UserControl
{
    public IQueryable<RadioShow> RadioShows { get; set; }

    private List<RadioShow> list1;
    private List<RadioShow> list2;
    private const string FORMAT_STRING = "<li><a href=\"{0}\">{1}</a></li>";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.RadioShows != null)
        {
            this.spreadData();
            this.populateLists();
        }
    }

    private void spreadData()
    {
        int items = this.RadioShows.Count<RadioShow>();
        int halfWay = Convert.ToInt32((Convert.ToDouble(items) + 0.5) / 2);

        list1 = new List<RadioShow>();
        list2 = new List<RadioShow>();

        int count = 0;
        var currentList = list1;

        foreach (var radioshow in this.RadioShows)
        {
            currentList.Add(radioshow);
            count++;

            if (count == halfWay)
            {
                currentList = list2;
            }
        }
    }

    private void populateLists()
    {
        this.populateList(this.litCol1, this.list1);
        this.populateList(this.litCol2, this.list2);
    }

    private void populateList(Literal litList, List<RadioShow> RadioShows)
    {
        var litText = new StringBuilder();

        foreach (var RadioShow in RadioShows)
        {
            var text = string.Format(FORMAT_STRING, Globals.GetUrl(RadioShow), RadioShow.DisplayName);
            litText.AppendLine(text);
        }

        litList.Text = litText.ToString();
    }
}
